#ifndef _MATRIX_H
#define _MATRIX_H

#include <iostream.h>
#include <assert.h>

// ---------------
// class Matrix<T>
// ---------------
template <class T>
class Matrix
{
public:
  typedef T value_type;
  
  Matrix(unsigned int rows, unsigned int cols)
    : m(rows), n(cols)
  {
    unsigned int size = m*n;
    assert (data = new T[size]);
  }

  Matrix (const Matrix<T> &A) 
  {
    m = A.m;
    n = A.n;
    unsigned int size = m*n;
    assert (data = new T[size]);
    for (int i=0; i<size; i++)
      data[i] = A.data[i];
  }

  ~Matrix()
  {
    delete [] data;
  }

  Matrix<T> &operator =(const Matrix<T> &A)
  {
    if (&A != this) {
      unsigned int size = A.m*A.n;
      if (size != m*n) {
	delete [] data;
	assert(data = new T[size]);
      }
      m = A.m;
      n = A.n;
      for (int i=0; i<size; i++)
	data[n] = x.data[n];
    }
    return *this;
  }

  T &operator ()(unsigned int i, unsigned int j)
  {
    assert (i<m && j<n);
    return data[i*n+j];
  }

  const T &operator()(unsigned int i, unsigned int j) const
  {
    assert (i<m && j<n);
    return data[i*n+j];
  }

  unsigned int rows() const
  {
    return m;
  }

  unsigned int cols() const
  {
    return n;
  }

  friend ostream &operator <<(ostream &os, const Matrix<T> &A)
  {
    for (unsigned int i=0; i<A.rows(); i++) {
      for (unsigned int j=0; j<A.cols(); j++)
        os << const_cast<T&>(A(i,j)) << " ";
      os << endl;
    }

    return os;
  }

protected:
  unsigned int m,n;
  T *data;
};

#endif

















