/*********************************************************************/
/*       fi_lib  --- A fast interval library (Version 1.1)           */
/*        (For copyright and info`s see file "fi_lib.h")             */
/*********************************************************************/

#include "ieee.h"
#include "global.h"

#ifdef FILIB_NAMESPACES
namespace filib 
{
#endif

double q_tanh(double x)
{
  double res;

  if (Double::isNaN(x))
#ifdef FILIB_EXTENDED
    return Double::QUIET_NAN();
#else
    res=q_abortnan(INV_ARG,&x,20);
#endif

  else 
  {
   if ((-1e-10<x) && (x<1e-10)) res=x; 
   else res=1.0/q_cth1(x); 
  }

  return(res);
}

#ifdef FILIB_NAMESPACES
}
#endif
